"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseRequest = void 0;
const functions = __importStar(require("firebase-functions"));
const logger_1 = require("../logger");
const utils_1 = require("../utils");
const https_1 = require("firebase-functions/v2/https");
var FirebaseRequest;
(function (FirebaseRequest_1) {
    function create(
    // eslint-disable-next-line @typescript-eslint/naming-convention
    FirebaseRequest, macKey, regions = []) {
        return (0, https_1.onRequest)({ region: regions }, async (request, response) => {
            const result = await (0, utils_1.execute)(async () => {
                const data = request.body;
                const verboseLogger = 'verboseLogger' in data && data.verboseLogger === true;
                const logger = logger_1.Logger.start('FirebaseRequest.create', null, 'info', verboseLogger);
                const verified = (0, utils_1.verifyMacTag)(data.macTag, data.parameters, macKey);
                if (!verified)
                    throw new functions.https.HttpsError('permission-denied', 'Invalid MAC tag');
                const firebaseRequest = new FirebaseRequest(logger.nextIndent);
                const parameters = firebaseRequest.parametersBuilder.build(data.parameters, logger.nextIndent);
                const returnValue = await firebaseRequest.execute(parameters);
                return utils_1.Flattable.flatten(returnValue);
            });
            response.send(result);
        });
    }
    FirebaseRequest_1.create = create;
})(FirebaseRequest = exports.FirebaseRequest || (exports.FirebaseRequest = {}));
