import type { FirebaseApp } from './FirebaseApp';
import type { FirebaseFunctions } from '../firebase';
import { type Flatten } from '../utils';
export declare class FirebaseFunctionsCaller<Functions extends FirebaseFunctions> {
    private readonly options;
    private readonly name;
    constructor(options: FirebaseApp.Options, name?: string);
    function<Key extends FirebaseFunctions.IsRecord<Functions> extends true ? keyof Functions & string : never>(key: Key): FirebaseFunctionsCaller<Functions[Key] & FirebaseFunctions>;
    private createMacTag;
    private get functionsInstance();
    callFunction(parameters: Flatten<FirebaseFunctions.FunctionParameters<Functions>>): Promise<FirebaseFunctions.FunctionReturnType<Functions>>;
    callRequest(parameters: Flatten<FirebaseFunctions.RequestParameters<Functions>>): Promise<FirebaseFunctions.RequestReturnType<Functions>>;
}
