import type { Flattable } from './Flattable';
export declare class UtcDate implements Flattable<string> {
    readonly year: number;
    readonly month: number;
    readonly day: number;
    readonly hour: number;
    readonly minute: number;
    constructor(year: number, month: number, day: number, hour: number, minute: number, timezone?: 'Europe/Berlin' | null);
    static get now(): UtcDate;
    get toDate(): Date;
    get toIsoDate(): string;
    get encoded(): string;
    static fromDate(date: Date): UtcDate;
    static fromIsoDate(date: string): UtcDate;
    static decode(encodedDate: string): UtcDate;
    setted(components: {
        year?: number;
        month?: number;
        day?: number;
        hour?: number;
        minute?: number;
    }): UtcDate;
    advanced(components: {
        year?: number;
        month?: number;
        day?: number;
        hour?: number;
        minute?: number;
    }): UtcDate;
    compare(other: UtcDate): 'less' | 'equal' | 'greater';
    get flatten(): string;
}
